
package cn.orionsec.ops.handler.importer.checker;

import cn.orionsec.kit.spring.SpringHolder;
import cn.orionsec.ops.constant.ImportType;
import cn.orionsec.ops.dao.WebhookConfigDAO;
import cn.orionsec.ops.entity.domain.WebhookConfigDO;
import cn.orionsec.ops.entity.importer.WebhookImportDTO;
import cn.orionsec.ops.entity.vo.data.DataImportCheckVO;
import org.apache.poi.ss.usermodel.Workbook;

import java.util.List;

public class WebhookDataChecker extends AbstractDataChecker<WebhookImportDTO, WebhookConfigDO> {

    private static final WebhookConfigDAO webhookConfigDAO = SpringHolder.getBean(WebhookConfigDAO.class);

    public WebhookDataChecker(Workbook workbook) {
        super(ImportType.WEBHOOK, workbook);
    }

    @Override
    protected DataImportCheckVO checkImportData(List<WebhookImportDTO> rows) {
        // 检查数据合法性
        this.validImportRows(rows);
        // 通过名称查询模板
        List<WebhookConfigDO> presentTemplates = this.getImportRowsPresentValues(rows,
                WebhookImportDTO::getName,
                webhookConfigDAO, WebhookConfigDO::getWebhookName);
        // 检查数据是否存在
        this.checkImportRowsPresent(rows, WebhookImportDTO::getName,
                presentTemplates, WebhookConfigDO::getWebhookName, WebhookConfigDO::getId);
        // 设置导入检查数据
        return this.setImportCheckRows(rows);
    }

}
